<?php
namespace MINAV\Layersliderlight\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Stefan Grothus <info@made-in-nature.de>, made in nature
 *  Manfred Rutschmann <rutschmann@agentur-volumen.de>, VOLUMEN Werbe-/Internetagentur
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
use MINAV\Layersliderlight\Domain\Model\FileReference;
use MINAV\Layersliderlight\Domain\Model\Slide;
use MINAV\Layersliderlight\Domain\Model\Slider;
use TYPO3\CMS\Backend\Utility\BackendUtility;
use TYPO3\CMS\Core\Messaging\AbstractMessage;
use TYPO3\CMS\Core\Resource\DuplicationBehavior;
use TYPO3\CMS\Core\Resource\File;
use TYPO3\CMS\Core\Resource\Folder;
use TYPO3\CMS\Core\Resource\ResourceStorage;
use TYPO3\CMS\Core\Resource\StorageRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\Generic\PersistenceManager;
use TYPO3\CMS\Extbase\Persistence\Generic\QueryResult;
use TYPO3\CMS\Extbase\Utility\DebuggerUtility;
use TYPO3\CMS\Recordlist\Browser\ElementBrowser;
use TYPO3\CMS\Core\Utility\VersionNumberUtility;

/**
 *
 *
 * @package layersliderlight
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class SliderController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

    /**
     * sliderRepository
     *
     * @var \MINAV\Layersliderlight\Domain\Repository\SliderRepository
     * @inject
     */
    protected $sliderRepository;

    /**
     * slideRepository
     *
     * @var \MINAV\Layersliderlight\Domain\Repository\SlideRepository
     * @inject
     */
    protected $slideRepository;

    /**
     * @var \TYPO3\CMS\Core\Resource\StorageRepository
     * @inject
     */
    protected $storageRepository;


    /**
     * @var \TYPO3\CMS\Extbase\Object\ObjectManager
     * @inject
     */
    protected $objectManager;

    /**
     * action list
     *
     * @return void
     */
    public function listAction() {
        if($this->settings['tsIncluded']!=1){
            echo '<p>You forgot to include the static extension template in the root template!</p>';
            return false;
        } else {
            $frameworkConfiguration = $this->configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_FRAMEWORK);
            /** @var QueryResult $sliders */
            $sliders = $this->sliderRepository->findAllBe($frameworkConfiguration['persistence']['storagePid']);
            $this->view->assign('sliders', $sliders);


        }


    }
    /**
     * action show
     *
     * @return string
     */
    public function showAction() {
        $this->settings['slider'] = str_replace('tx_layersliderlight_domain_model_slider_', "", $this->settings['slider']);
        if (($view = GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Cache\\CacheManager')->getCache('tx_layersliderlight_pi1_show_cache')->get('slider_'.$this->settings['slider'])) === false ) {
            if($this->settings['slider'] > 0){
                /** @var Slider $slider */
                $slider = $this->sliderRepository->findByUid((int)$this->settings['slider']);
                if($slider != NULL){
                    $options = $slider->getOptions();
                    if(strlen($options['skinsPath']) > 1){
                        $explodedPath = explode("/", $options['skinsPath']);
                        $newSkin = $explodedPath[count($explodedPath) - 1];
                        $lastPosition = strripos($options['skinsPath'], "/");
                        $newSkinsPath = ltrim(substr($options['skinsPath'], 0, $lastPosition)."/", "/");
                        $options['skinsPath'] = $newSkinsPath;
                        $options['skin'] = $newSkin;
                        $slider->setOptions(json_encode($options));
                    }
                    $this->view->assign( 'slider',  $slider);
                } else {
                    $this->addFlashMessage('The given Slider was not found');
                }
            }
            $this->view->assign( 'slider',  $slider)->assign('tsincluded', $this->settings['tsIncluded']);
            $output = $this->view->render();
            $view = $this->sanitize_output($output);
            GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Cache\\CacheManager')->getCache('tx_layersliderlight_pi1_show_cache')->set('slider_'.$this->settings['slider'],
                $view, array(), $this->calculateCacheLifetimeFromSlider($this->sliderRepository->findByUid((int)$this->settings['slider'])));
        }
        return $view;
    }

    /**
     * @param Slider $slider
     * @return integer
     */
    private function calculateCacheLifetimeFromSlider(Slider $slider)
    {

        /** @var integer $lifetime */
        $lifetime = 0;

        /** @var QueryResult $slides */
        $slides = $this->slideRepository->findBySliderForCacheGeneration($slider);

        if ($slides->count() > 0) {
            /** @var Slide $slide */
            foreach ($slides as $slide) {
                if ($slide->getEndtime() > time()) {
                    if (($lifetime == 0) || ($lifetime > $slide->getEndtime())) {
                        $lifetime = $slide->getEndtime();
                    }
                }
                if ($slide->getStarttime() > time()) {
                    echo 1;
                    if (($lifetime == 0) || ($lifetime > $slide->getStarttime())) {

                        $lifetime = $slide->getStarttime();
                    }
                }
            }
            if ($lifetime > 0) {
                $lifetime = $lifetime - time();
            }
        }
        return $lifetime;
    }
    /**
     * @param $buffer
     * @return mixed
     */
    protected function sanitize_output($buffer) {

        $search = array(
            '/\>[^\S ]+/s',  // strip whitespaces after tags, except space
            '/[^\S ]+\</s',  // strip whitespaces before tags, except space
            '/(\s)+/s'       // shorten multiple whitespace sequences
        );

        $replace = array(
            '>',
            '<',
            '\\1'
        );

        $buffer = preg_replace($search, $replace, $buffer);

        return $buffer;
    }

    /**
     * action new
     *
     * @param Slider $newSlider
     * @dontvalidate $newSlider
     * @return void
     */
    public function newAction(Slider $newSlider = NULL) {
        $this->view->assign('newSlider', $newSlider);
    }

    /**
     * action create
     *
     * @param Slider $newSlider
     * @return void
     */
    public function createAction(Slider $newSlider) {
        $newSlider->setUsefal(true);
        $this->sliderRepository->add($newSlider);
        /** @var PersistenceManager $persistenceManager */
        $persistenceManager = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\PersistenceManager');
        $persistenceManager->persistAll();
        $this->addFlashMessage('Your new Slider was created.');
        $this->redirect('edit', NULL, NULL, array('slider' => $newSlider));
    }

    /**
     * action edit
     *
     * @param Slider $slider
     * @return void
     */
    public function editAction(Slider $slider) {
        if($slider->getUsefal() === false){
            $this->redirect('updatefal', NULL, NULL, array('slider' => $slider));
        }
        /** @var array $options */
        $options = $slider->getOptions();
        if(strlen($options['skinsPath']) > 1){
            $explodedPath = explode("/", $options['skinsPath']);
            $newSkin = $explodedPath[count($explodedPath) - 1];
            $lastPosition = strripos($options['skinsPath'], "/");
            $newSkinsPath = "/".ltrim(substr($options['skinsPath'], 0, $lastPosition)."/", "/");
            $options['skinsPath'] = $newSkinsPath;
            $options['skin'] = $newSkin;
        }
        $this->view->assign('fileWizardUrl', BackendUtility::getModuleUrl('wizard_element_browser',array('mode' => 'file', false, true)));
        $this->view->assign('linkWizardUrl', BackendUtility::getModuleUrl('wizard_element_browser',array('mode' => 'wizard', false, true)));
        $this->view->assign( 'slider', $slider)->assign('options', $options);
    }


    /**
     * @param Slider $slider
     * @param array $updateformsettings
     */
    public function updatefalAction(Slider $slider = NULL, $updateformsettings=NULL){
        /** @var array $storages */
        $storages = $this->storageRepository->findAll();
        if($updateformsettings === NULL){
            $updateformsettings['slider'] = $slider;
            $updateformsettings['storage'] = $storages[0];
            /** @var ResourceStorage $selectedResourceStorage */
            $selectedResourceStorage = $storages[0];
        } else {
            if((int)$updateformsettings['storage'] > 0){
                /** @var ResourceStorage $selectedResourceStorage */
                $selectedResourceStorage = $this->storageRepository->findByUid((int)$updateformsettings['storage']);
            }
            if((int)$updateformsettings['slider'] > 0){
                $slider = $this->sliderRepository->findByUid((int)$updateformsettings['slider']);
            }
        }
        if($updateformsettings['process']){
            $this->redirect('doupdatefal', NULL,NULL, array('slider' => $slider, 'updateformsettings' => $updateformsettings));
        }
        $foldersInResourceStorage = $selectedResourceStorage->getFoldersInFolder($selectedResourceStorage->getRootLevelFolder(), 0, 999, true, true);
        asort($foldersInResourceStorage);
        $this->view
            ->assign('slider', $slider)
            ->assign('storages', $storages)
            ->assign('updateformsettings', $updateformsettings)
            ->assign('foldersInResourceStorage', $foldersInResourceStorage)
        ;
    }

    /**
     * @param Slider $slider
     * @param array $updateformsettings
     */
    public function doupdatefalAction(Slider $slider, $updateformsettings) {
        /** @var ResourceStorage $resourceStorage */
        $resourceStorage = $this->storageRepository->findByUid((int)$updateformsettings['storage']);
        /** @var Folder $folder */
        $folder = $resourceStorage ->getFolder($updateformsettings['selectedFolder']);
        if($slider->getSlides()->count() > 0){
            /** @var Slide $slide */
            foreach($slider->getSlides() as $slide){

                /** @var File $fileObject */
                if(file_exists(GeneralUtility::getFileAbsFileName('uploads/tx_layersliderlight/'.$slide->getImage()))){
                    if ( VersionNumberUtility::convertVersionNumberToInteger(TYPO3_version) >= 7003999 ) {
                        $fileObject = $folder->addFile(
                            GeneralUtility::getFileAbsFileName('uploads/tx_layersliderlight/'.$slide->getImage()), NULL, DuplicationBehavior::RENAME
                        );
                    } else {
                        $fileObject = $folder->addFile(
                            GeneralUtility::getFileAbsFileName('uploads/tx_layersliderlight/'.$slide->getImage()), NULL, 'rename'
                        );
                    }


                    /** @var FileReference $fileReference */
                    $fileReference = $this->objectManager->get('MINAV\\Layersliderlight\\Domain\\Model\\FileReference');
                    $fileReference->setFile($fileObject);

                    $slide->setFalimage($fileReference);
                    $this->addFlashMessage('Image for Slide <strong>'.$slide->getUid().':'.$slide->getTitle().'</strong> processed. Old storage: uploads/tx_layersliderlight/'.$slide->getImage().' => to new storage: '.$fileObject->getPublicUrl(), 'Success', AbstractMessage::OK);
                } else {
                    $this->addFlashMessage('The given image for Slide <strong>'.$slide->getUid().':'.$slide->getTitle().'</strong> was not found: uploads/tx_layersliderlight/'.$slide->getImage(), 'Error', AbstractMessage::ERROR);
                }
            }
            $slider->setUsefal(true);
            $this->sliderRepository->update($slider);
            $this->view->assign('slider', $slider);
        }
    }

    /**
     * @param Slider $slider
     * @param Slide $slide
     * @return void
     */
    public function copyAction(Slider $slider){

        /** @var Slider $sliderCopy */
        $sliderCopy = $this->objectManager->get('MINAV\\Layersliderlight\\Domain\\Model\\Slider');

        /** @var PersistenceManager $persistenceManager */
        $persistenceManager = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\PersistenceManager');
        $sliderCopy->setTitle('Copy from: '.$slider->getTitle());
        $sliderCopy->setOptions(json_encode($slider->getOptions()),true);
        $sliderCopy->setUsefal(true);
        $this->sliderRepository->add($sliderCopy);
        $persistenceManager->persistAll();

        if($slider->getSlides()->count() > 0){
            foreach($slider->getSlides() as $slide){
                /** @var Slide $slideCopy */
                $slideCopy = $this->objectManager->get('MINAV\\Layersliderlight\\Domain\\Model\\Slide');
                $slideCopy->setTitle($slide->getTitle());
                $slideCopy->setConfiguration($slide->getConfiguration());
                $slideCopy->setSorting($slide->getSorting());
                $slideCopy->setSlider($sliderCopy);
                if($slide->getFalimage() !== NULL){
                    /** @var FileReference $fileReference */
                    $fileReference = $this->objectManager->get('MINAV\\Layersliderlight\\Domain\\Model\\FileReference');
                    $fileReference->setFile($slide->getFalimage()->getOriginalResource()->getOriginalFile());
                    $slideCopy->setFalimage($fileReference);
                }

                $slideCopy->setTitle($slideCopy->getTitle());
                $this->slideRepository->add($slideCopy);
                $persistenceManager->persistAll();
            }
        }
        $this->redirect('list', NULL, NULL);
    }

    /**
     * Initializes the current action
     * @return void
     */
    public function initializeUpdateAction() {
        if (isset($this->arguments['slider'])) {
            $this->arguments['slider']->getPropertyMappingConfiguration()->allowProperties('formslides');
            $this->arguments['slider']->getPropertyMappingConfiguration()->allowProperties('formitems');
        }
    }

    /**
     * action update
     *
     * @param Slider $slider
     * @return void
     */
    public function updateAction(Slider $slider) {
        $sliderFormData = $slider->getFormslides();
        if(is_array($sliderFormData)){
            $i = 0;
            foreach ($sliderFormData as $fsKey => $fsVal) {
                // handle the slides
                /** @var Slide $existingSlide */
                $existingSlide = $this->slideRepository->findByUid($fsKey);
                if($existingSlide instanceof Slide){
                    $existingSlide->setTitle($fsVal['title']);
                    $existingSlide->setSorting($i);
                    $existingSlide->setConfiguration( $fsVal['configuration'] );
                    $existingSlide->setHidden($fsVal['hidden']);

                    if($fsVal['starttime'] > 0){ $existingSlide->setStarttime(strtotime($fsVal['starttime'])); }
                    else { $existingSlide->setStarttime(0);}

                    if($fsVal['endtime'] > 0){ $existingSlide->setEndtime(strtotime($fsVal['endtime'])); }
                    else { $existingSlide->setEndtime(0); }

                    if($fsVal['fileReference']){
                        $existingSlide->getFalimage()->setTitle($fsVal['fileReference']['title']);
                        $existingSlide->getFalimage()->setAlternative($fsVal['fileReference']['alternative']);
                    }

                    $this->slideRepository->update($existingSlide);
                }
                $i++;
            }
        }
        $this->sliderRepository->update($slider);
        /** @var PersistenceManager $persistenceManager */
        $persistenceManager = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\PersistenceManager');
        $persistenceManager->persistAll();
        GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Cache\\CacheManager')->getCache('tx_layersliderlight_pi1_show_cache')->remove('slider_'.$slider->getUid());
        $this->addFlashMessage('Your Slider was updated');
        $this->redirect('edit', NULL, NULL, array('slider' => $slider));
    }

    /**
     * action delete
     *
     * @param Slider $slider
     * @return void
     */
    public function deleteAction(Slider $slider) {
        if($slider->getSlides()->count() > 0){
            foreach($slider->getSlides() as $slide){
                $into_table  ='sys_file_reference';
                $where_clause='uid_foreign ='.$slide->getUid().' AND tablenames="tx_layersliderlight_domain_model_slide" AND fieldname="falimage" AND table_local="sys_file"';
                $field_values = array('deleted' => 1);
                $GLOBALS['TYPO3_DB']->exec_UPDATEquery( $into_table, $where_clause, $field_values);
            }
        }
        $this->sliderRepository->remove($slider);
        $this->addFlashMessage('Your Slider was removed.');
        $this->redirect('list');
    }

}
?>